import json

import requests


def print_json_pretty(obj):
    print(json.dumps(obj, indent=4, ensure_ascii=False))


def print_json_plain(obj):
    print(json.dumps(obj, ensure_ascii=False))


def req(url, json_dict, headers=None):
    res = requests.post(url, json=json_dict, headers=headers)
    print_json_pretty(res.json())
    return res.json()


def reqGet(url, params, headers=None):
    res = requests.get(url, params=params, headers=headers)
    print_json_pretty(res.json())
    return res.json()


def reqForm(url, formData, headers=None):
    res = requests.post(url, data=formData, headers=headers)
    print_json_pretty(res.json())
    return res.json()


def reqDelete(url, jsonData, headers=None):
    res = requests.delete(url, json=jsonData, headers=headers)
    print_json_pretty(res.json())
    return res.json()


def reqPut(url, jsonData, headers=None):
    res = requests.put(url, json=jsonData, headers=headers)
    print_json_pretty(res.json())
    return res.json()
