import json
import unittest

import requests


def print1(obj):
    print(json.dumps(obj, indent=4, ensure_ascii=False))


def get_token():
    headers = {
        'authority': 'aimp.aimpdev.k5.bigtree.tech',
        'accept': 'application/json, text/plain, */*',
        'accept-language': 'zh-CN,zh;q=0.9,en;q=0.8',
    }

    json_data = {
        'username': 'lzq',
        'password': 'Aa123456',
        'token': True,
    }

    response = requests.post('https://aimp.aimpdev.k5.bigtree.tech/api/aimp-auth-web/auth/login', headers=headers, json=json_data)
    return response.json()['token']


class MyTest(unittest.TestCase):
    def setUp(self) -> None:
        # self.host = "https://edsp.rxdpdev.k5.bigtree.tech/api/rxdp-xdata-web/rxdp-file"
        self.host = "http://127.1:8080"
        self.head = {
            "Access-Token": get_token()
        }

    def test_invoke(self):
        url = "http://127.0.0.1:8080/out_api/processInvoke/shui_test"
        data = {"taxpayer_id": "91320585MA1NUBLR8L", "apikey": "8290b473ed6c42eaa6e1ed0ec68c1c3d", "apisecret": "n4FBN9youmxXUEIUtM9J5EfwItZGFx34nimJgv0xsP26WbLcG8QcE2HK0jzXu0cRR35Q1QDjg5HUQuApq7mimA"}
        header = {
            "appId": "tian_test",
            "secret": "ZryZsW6er-kaYxSjLwJ8XtAUtP0kowhZ"
        }
        print(requests.post(url, json=data, headers=header).json())
