import json

def convert_format(input_str):
    try:
        # 解析输入字符串为Python字典
        input_data = json.loads(input_str)

        # 构建输出数组
        output_list = []

        # 遍历每个键值对
        for category_name, items in input_data.items():
            output_item = {
                "name": category_name,
                "datas": items
            }
            output_list.append(output_item)

        # 转换为JSON字符串并返回
        return json.dumps(output_list, ensure_ascii=False)

    except Exception as e:
        return f"转换出错: {str(e)}"

# 示例输入（多个key的情况）
input_example = """
{"常用工具":[{"title":"语雀图床","icon":"https://www.yuque.com/favicon.ico","mainUrl":"https://www.yuque.com/tianyunperfect/fg7hif/ecw4pcgn1y2ise60","description":"","extraUrls":[],"screenshot":"https://cdn.nlark.com/yuque/0/2025/png/241764/1743498516801-1b9a7c09-055e-4f87-b848-ef8168ba5445.png?x-oss-process=image%2Fformat%2Cwebp"}]}
"""

# 执行转换
output_example = convert_format(input_example)
print(output_example)